#include <Keyboard.h>
#include <EEPROM.h>

#define testbit(data,bitno) ((data>>bitno)&0x01)
#define bit_set(var,bitno) ((var) |= 1 << (bitno))
#define bit_clr(var,bitno) ((var) &= ~(1 << (bitno)))

//*********************Global Variables*******************//
unsigned int up = 0;
unsigned char eU = EEPROM.read(0);        
unsigned int down = 0;
unsigned char eD = EEPROM.read(1);
unsigned int left = 0;
unsigned char eL = EEPROM.read(2);
unsigned int right = 0;
unsigned char eR = EEPROM.read(3);

unsigned int a = 0;
unsigned char eA = EEPROM.read(4);
unsigned int b = 0;
unsigned char eB = EEPROM.read(5);
unsigned int x = 0;
unsigned char eX = EEPROM.read(6);
unsigned int y = 0;
unsigned char eY = EEPROM.read(7);

unsigned int start = 0;
unsigned char eST = EEPROM.read(8);
unsigned int select = 0;
unsigned char eSE = EEPROM.read(9);

unsigned int l_1 = 0;
unsigned char eL_1 = EEPROM.read(10);
unsigned int r_1 = 0;
unsigned char eR_1 = EEPROM.read(11);
unsigned int l_2 = 0;
unsigned int r_2 = 0;

unsigned int Home = 0;
unsigned char eHome = EEPROM.read(12);

unsigned int up_flg = 0;
unsigned int down_flg = 0;
unsigned int left_flg = 0;
unsigned int right_flg = 0;

unsigned int a_flg = 0;
unsigned int b_flg = 0;
unsigned int x_flg = 0;
unsigned int y_flg = 0;

unsigned int start_flg = 0;
unsigned int select_flg = 0;

unsigned int l_1_flg = 0;
unsigned int r_1_flg = 0;

unsigned int home_flg = 0;

uint16_t button_state = 0;  //all button values concatenated to 16bit word
uint8_t  serial_byte = 0; //temp variable to hold 1byte commands received over BT
String serial_cmd;

String temp;
String cmd;
String arg;
int num=0;
unsigned char serial_flg=0;
unsigned char controller_flg=1;
unsigned char i=1;

void tokenize(String str){
  cmd="";
  arg="";
  int sz=str.length();
  char flg=0;
  for(int i=0;i<sz;i++){
    if(str.charAt(i)!=' '){
      if(flg==0){
        cmd.concat(str.charAt(i));
      }else{
        arg.concat(str.charAt(i));
      }
    }else{flg++;}
  }
  if(flg>1){cmd="err";}
  num=arg.toInt();
}

unsigned char keyarg(String str){
  if(str.length()==1){return str.charAt(0);}
  if(str=="KEY_LEFT_CTRL"){return 0x80;}
  else if(str=="KEY_LEFT_SHIFT"){return 0x81;}
  else if(str=="KEY_LEFT_ALT"){return 0x82;}
  else if(str=="KEY_LEFT_GUI"){return 0x83;}
  else if(str=="KEY_RIGHT_CTRL"){return 0x84;}
  else if(str=="KEY_RIGHT_SHIFT"){return 0x85;}
  else if(str=="KEY_RIGHT_ALT"){return 0x86;}
  else if(str=="KEY_RIGHT_GUI"){return 0x87;}
  else if(str=="KEY_UP_ARROW"){return 0xDA;}
  else if(str=="KEY_DOWN_ARROW"){return 0xD9;}
  else if(str=="KEY_LEFT_ARROW"){return 0xD8;}
  else if(str=="KEY_RIGHT_ARROW"){return 0xD7;}
  else if(str=="KEY_BACKSPACE"){return 0xB2;}
  else if(str=="KEY_TAB"){return 0xB3;}
  else if(str=="KEY_RETURN"){return 0xB0;}
  else if(str=="KEY_ESC"){return 0xB1;}
  else if(str=="KEY_INSERT"){return 0xD1;}
  else if(str=="KEY_DELETE"){return 0xD4;}
  else if(str=="KEY_PAGE_UP"){return 0xD3;}
  else if(str=="KEY_PAGE_DOWN"){return 0xD6;}
  else if(str=="KEY_HOME"){return 0xD2;}
  else if(str=="KEY_END"){return 0xD5;}
  else if(str=="KEY_CAPS_LOCK"){return 0xC1;}
  else if(str=="KEY_F1"){return 0xC2;}
  else if(str=="KEY_F2"){return 0xC3;}
  else if(str=="KEY_F3"){return 0xC4;}
  else if(str=="KEY_F4"){return 0xC5;}
  else if(str=="KEY_F5"){return 0xC6;}
  else if(str=="KEY_F6"){return 0xC7;}
  else if(str=="KEY_F7"){return 0xC8;}
  else if(str=="KEY_F8"){return 0xC9;}
  else if(str=="KEY_F9"){return 0xCA;}
  else if(str=="KEY_F10"){return 0xCB;}
  else if(str=="KEY_F11"){return 0xCC;}
  else if(str=="KEY_F12"){return 0xCD;}
}

void argkey(unsigned char hex){
  if(hex==0x80){Serial.print("KEY_LEFT_CTRL");}
  else if(hex==0x81){Serial.print("KEY_LEFT_SHIFT");}
  else if(hex==0x82){Serial.print("KEY_LEFT_ALT");}
  else if(hex==0x83){Serial.print("KEY_LEFT_GUI");}
  else if(hex==0x84){Serial.print("KEY_RIGHT_CTRL");}
  else if(hex==0x85){Serial.print("KEY_RIGHT_SHIFT");}
  else if(hex==0x86){Serial.print("KEY_RIGHT_ALT");}
  else if(hex==0x87){Serial.print("KEY_RIGHT_GUI");}
  else if(hex==0xDA){Serial.print("KEY_UP_ARROW");}
  else if(hex==0xD9){Serial.print("KEY_DOWN_ARROW");}
  else if(hex==0xD8){Serial.print("KEY_LEFT_ARROW");}
  else if(hex==0xD7){Serial.print("KEY_RIGHT_ARROW");}
  else if(hex==0xB2){Serial.print("KEY_BACKSPACE");}
  else if(hex==0xB3){Serial.print("KEY_TAB");}
  else if(hex==0xB0){Serial.print("KEY_RETURN");}
  else if(hex==0xB1){Serial.print("KEY_ESC");}
  else if(hex==0xD1){Serial.print("KEY_INSERT");}
  else if(hex==0xD4){Serial.print("KEY_DELETE");}
  else if(hex==0xD3){Serial.print("KEY_PAGE_UP");}
  else if(hex==0xD6){Serial.print("KEY_PAGE_DOWN");}
  else if(hex==0xD2){Serial.print("KEY_HOME");}
  else if(hex==0xD5){Serial.print("KEY_END");}
  else if(hex==0xC1){Serial.print("KEY_CAPS_LOCK");}
  else if(hex==0xC2){Serial.print("KEY_F1");}
  else if(hex==0xC3){Serial.print("KEY_F2");}
  else if(hex==0xC4){Serial.print("KEY_F3");}
  else if(hex==0xC5){Serial.print("KEY_F4");}
  else if(hex==0xC6){Serial.print("KEY_F5");}
  else if(hex==0xC7){Serial.print("KEY_F6");}
  else if(hex==0xC8){Serial.print("KEY_F7");}
  else if(hex==0xC9){Serial.print("KEY_F8");}
  else if(hex==0xCA){Serial.print("KEY_F9");}
  else if(hex==0xCB){Serial.print("KEY_F10");}
  else if(hex==0xCC){Serial.print("KEY_F11");}
  else if(hex==0xCD){Serial.print("KEY_F12");}
  else{Serial.print((char) hex);}
}

void setup() {
  Serial1.begin(38400); //Use RX pin0 and TX pin1 for bluetooth (5v operation, need 3.3v level shift protection!!!)
  Serial.begin(9600);   //USB serial for config
/*  delay(1000);
  Serial.println(F("USB BT Receiver Config v1.0"));
  Serial.println(F("sjm4306 12202018"));
  Serial.println(F("Enter UP,DN,LT,RT, A,B,X,Y, ST,SE, SL,SR, Home followed by a Key to Map to"));
  Serial.println(F("For List of Modifier Keys Type 'Help'"));
  Serial.println("");
  Serial.print(F("> "));*/
  
  pinMode(13, OUTPUT);        //Button Press Status

  //*********************Pin Assignments********************//

  Keyboard.begin();
}

//                 Byte 1                   Byte 0
//button_state     15 14 13 12 11 10 9  8 | 7 6 5 4 3 2 1 0
//             MSB 0  0  0  0  0  0  0  0 | 0 0 0 0 0 0 0 0 LSB
//                 1  x  H  Lt Rt St Se U | 0 D L R A B X Y  

void loop() {
  while(Serial.available()){
    Keyboard.end();
    serial_flg=1;
    temp=Serial.readString();
    Serial.println(temp);
    Keyboard.begin();
  }
  
  if(serial_flg==1){
    Keyboard.end();
    //temp.toUpperCase();
    tokenize(temp);
    serial_flg=0;
    controller_flg=0;
    if(temp=="Help" || i==1){
      Serial.println(F("USB BT Receiver Config v1.0"));
      Serial.println(F("sjm4306 12202018"));
      Serial.println("");
      Serial.println(F("Enter UP,DN,LT,RT, A,B,X,Y, ST,SE, SL,SR, Home followed by a Key to Map to"));
      Serial.println(F("For List of Modifier Keys Type 'Help'"));
      Serial.println(F("List - Display Current Button Mapping Settings"));
      Serial.println(F("Exit - Exits Programming Mode"));
      Serial.println("");
      Serial.println(F("Modifiers:"));
      Serial.println(F("KEY_LEFT_CTRL,  KEY_LEFT_SHIFT,  KEY_LEFT_ALT,   KEY_LEFT_GUI"));
      Serial.println(F("KEY_RIGHT_CTRL, KEY_RIGHT_SHIFT, KEY_RIGHT_ALT,  KEY_RIGHT_GUI"));
      Serial.println(F("KEY_UP_ARROW,   KEY_DOWN_ARROW,  KEY_LEFT_ARROW, KEY_RIGHT_ARROW"));
      Serial.println(F("KEY_BACKSPACE,  KEY_TAB,         KEY_RETURN,     KEY_ESC"));
      Serial.println(F("KEY_INSERT,     KEY_DELETE,      KEY_PAGE_UP,    KEY_PAGE_DOWN"));
      Serial.println(F("KEY_HOME,       KEY_END,         KEY CAPS_LOCK,  KEY_F1 thru F12"));
      i=0;
    }else if(cmd=="UP"){
      eU=keyarg(arg);
      EEPROM.write(0,eU);
      Serial.print(F("OK, 0x"));Serial.print(eU,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="DN"){
      eD=keyarg(arg);
      EEPROM.write(1,eD);
      Serial.print(F("OK, 0x"));Serial.print(eD,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="LT"){
      eL=keyarg(arg);
      EEPROM.write(2,eL);
      Serial.print(F("OK, 0x"));Serial.print(eL,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="RT"){
      eR=keyarg(arg);
      EEPROM.write(3,eR);
      Serial.print(F("OK, 0x"));Serial.print(eR,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="A"){
      eA=keyarg(arg);
      EEPROM.write(4,eA);
      Serial.print(F("OK, 0x"));Serial.print(eA,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="B"){
      eB=keyarg(arg);
      EEPROM.write(5,eB);
      Serial.print(F("OK, 0x"));Serial.print(eB,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="X"){
      eX=keyarg(arg);
      EEPROM.write(6,eX);
      Serial.print(F("OK, 0x"));Serial.print(eX,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="Y"){
      eY=keyarg(arg);
      EEPROM.write(7,eY);
      Serial.print(F("OK, 0x"));Serial.print(eY,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="ST"){
      eST=keyarg(arg);
      EEPROM.write(8,eST);
      Serial.print(F("OK, 0x"));Serial.print(eST,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="SE"){
      eSE=keyarg(arg);
      EEPROM.write(9,eSE);
      Serial.print(F("OK, 0x"));Serial.print(eSE,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="SL"){
      eL_1=keyarg(arg);
      EEPROM.write(10,eL_1);
      Serial.print(F("OK, 0x"));Serial.print(eL_1,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="SR"){
      eR_1=keyarg(arg);
      EEPROM.write(11,eR_1);
      Serial.print(F("OK, 0x"));Serial.print(eR_1,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="Home"){
      eHome=keyarg(arg);
      EEPROM.write(12,eHome);
      Serial.print(F("OK, 0x"));Serial.print(eHome,HEX);Serial.print(" ");Serial.println(arg);
    }else if(cmd=="List"){
      Serial.print("UP = ");argkey(eU);Serial.print(", 0x");Serial.println(eU,HEX);
      Serial.print("DN = ");argkey(eD);Serial.print(", 0x");Serial.println(eD,HEX);
      Serial.print("LT = ");argkey(eL);Serial.print(", 0x");Serial.println(eL,HEX);
      Serial.print("RT = ");argkey(eR);Serial.print(", 0x");Serial.println(eR,HEX);
      Serial.print("A = ");argkey(eA);Serial.print(", 0x");Serial.println(eA,HEX);
      Serial.print("B = ");argkey(eB);Serial.print(", 0x");Serial.println(eB,HEX);
      Serial.print("X = ");argkey(eX);Serial.print(", 0x");Serial.println(eX,HEX);
      Serial.print("Y = ");argkey(eY);Serial.print(", 0x");Serial.println(eY,HEX);
      Serial.print("ST = ");argkey(eST);Serial.print(", 0x");Serial.println(eST,HEX);
      Serial.print("SE = ");argkey(eSE);Serial.print(", 0x");Serial.println(eSE,HEX);
      Serial.print("SL = ");argkey(eL_1);Serial.print(", 0x");Serial.println(eL_1,HEX);
      Serial.print("SR = ");argkey(eR_1);Serial.print(", 0x");Serial.println(eR_1,HEX);
      Serial.print("Home = ");argkey(eHome);Serial.print(", 0x");Serial.println(eHome,HEX);
    }else if(cmd=="Exit"){
      Serial.println(F("Goodbye"));
      i=1;
      controller_flg=1;
      Keyboard.begin();
    }else if(i!=1){
      Serial.println(F("-Invalid Command, type 'Help' for list of available commands"));
    }

    Serial.println("");
    Serial.print("> ");  
  }

  if(controller_flg==1){
    if(Serial1.available()>0){
       serial_byte=Serial1.read(); //if BT command byte was received read/save value
       if(testbit(serial_byte, 7) == 1){  //update upper byte of 16bit word
         button_state &= 0x00FF;
         button_state |= serial_byte<<8;
       }else{               //update lower byte of 16bit word
         button_state &= 0xFF00;
         button_state |= serial_byte;
       }
     }
    
    if(testbit(button_state,8)){
      Keyboard.press(eU);//KEY_UP_ARROW);
      up_flg=1;
    }else if(up_flg==1){
      Keyboard.release(eU);//KEY_UP_ARROW);
      up_flg=0;
    }
  
    if(testbit(button_state,6)){
      Keyboard.press(eD);//KEY_DOWN_ARROW);
      down_flg=1;
    }else if(down_flg==1){
      Keyboard.release(eD);//KEY_DOWN_ARROW);
      down_flg=0;
    }
  
    if(testbit(button_state,5)){
      Keyboard.press(eL);//KEY_LEFT_ARROW);
      left_flg=1;
    }else if(left_flg==1){
      Keyboard.release(eL);//KEY_LEFT_ARROW);
      left_flg=0;q
    }
  
    if(testbit(button_state,4)){
      Keyboard.press(eR);//KEY_RIGHT_ARROW);
      right_flg=1;
    }else if(right_flg==1){
      Keyboard.release(eR);//KEY_RIGHT_ARROW);
      right_flg=0;
    }
  
    
    if(testbit(button_state,3)){
      Keyboard.press(eA);//'a');
      a_flg=1;
    }else if(a_flg==1){
      Keyboard.release(eA);//'a');
      a_flg=0;
    }
  
    if(testbit(button_state,2)){
      Keyboard.press(eB);//'b');
      b_flg=1;
    }else if(b_flg==1){
      Keyboard.release(eB);//'b');
      b_flg=0;
    }
  
    if(testbit(button_state,1)){
      Keyboard.press(eX);//'x');
      x_flg=1;
    }else if(x_flg==1){
      Keyboard.release(eX);//'x');
      x_flg=0;
    }
  
    if(testbit(button_state,0)){
      Keyboard.press(eY);//'y');
      y_flg=1;
    }else if(y_flg==1){
      Keyboard.release(eY);//'y');
      y_flg=0;
    }
    
  
    if(testbit(button_state,10)){
      Keyboard.press(eST);//'3');//KEY_RETURN);
      start_flg=1;
    }else if(start_flg==1){
      Keyboard.release(eST);//'3');//KEY_RETURN);
      start_flg=0;
    }
  
    if(testbit(button_state,9)){
      Keyboard.press(eSE);//'4');//KEY_BACKSPACE);
      select_flg=1;
    }else if(select_flg==1){
      Keyboard.release(eSE);//'4');//KEY_BACKSPACE);
      select_flg=0;
    }
    
  
    if(testbit(button_state,12)){
      Keyboard.press(eL_1);//'1');
      l_1_flg=1;
    }else if(l_1_flg==1){
      Keyboard.release(eL_1);//'1');
      l_1_flg=0;
    }
  
    if(testbit(button_state,11)){
      Keyboard.press(eR_1);//'2');
      r_1_flg=1;
    }else if(r_1_flg==1){
      Keyboard.release(eR_1);//'2');
      r_1_flg=0;
    }
  
    if(testbit(button_state,13)){
      Keyboard.press(eHome);
      home_flg=1;
    }else if(home_flg==1){
      Keyboard.release(eHome);
      home_flg=0;
    }
  
    if(button_state != 0x8000){
      PORTC |=0x80;//PORTB |= 0b00100000; //digitalWrite(13,HIGH)
    }else{
      PORTC &=0x7F;//PORTB &= 0b11011111; //digitalWrite(13,LOW);
    }
  }
}
